USE NORTHWIND
GO
--O TOP TRAZ OS PRIMEIROS x REGISTROS
SELECT DISTINCT TOP 5 PRODUCTID, QUANTITY
  FROM [ORDER DETAILS]
 ORDER BY QUANTITY DESC
--TOP WITH TIES TRAZ O EMPATE NA ULTIMA POSICAO
SELECT DISTINCT TOP 5 WITH TIES PRODUCTID,QUANTITY
  FROM [ORDER DETAILS]
 ORDER BY QUANTITY DESC
--FUNCOES AGREGADAS SEM QUEBRA
SELECT MAX(UNITPRICE),MIN(UNITPRICE),
       AVG(QUANTITY),COUNT(*),COUNT(DISTINCT PRODUCTID),
       COUNT(DISTINCT ORDERID)
  FROM [ORDER DETAILS]
--CONSULTA COM TOTAIS E QUEBRAS
SELECT PRODUCTID, SUM(QUANTITY), COUNT(*)
  FROM [ORDER DETAILS]
 GROUP BY PRODUCTID
 ORDER BY PRODUCTID
--UTILIZACAO DO HAVING E DO WHERE
SELECT PRODUCTID, SUM(QUANTITY), COUNT(*)
  FROM [ORDER DETAILS]
 WHERE QUANTITY > 100
 GROUP BY PRODUCTID
SELECT PRODUCTID, SUM(QUANTITY), COUNT(*)
  FROM [ORDER DETAILS]
 GROUP BY PRODUCTID
HAVING SUM(QUANTITY) > 100
--ROLLUP GERA SUBTOTAIS A CADA PRODUTO, MANTENDO O ANALITICO E RETIRANDO AS COLUNAS DE TRAZ PARA FRENTE
SELECT ORDERID, PRODUCTID, SUM(QUANTITY) AS QUANT_TOTAL,
       SUM(QUANTITY*UNITPRICE) AS VALOR_TOTAL
 FROM [ORDER DETAILS]
 GROUP BY ORDERID, PRODUCTID WITH ROLLUP
 ORDER BY ORDERID, PRODUCTID
--CUBE GERA UM ROLLUP COM TODAS AS COMBINACOES POSSIVEIS ENTRE OS VALORES
SELECT ORDERID, PRODUCTID, SUM(QUANTITY) AS QUANT_TOTAL,
       SUM(QUANTITY*UNITPRICE) AS VALOR_TOTAL
 FROM [ORDER DETAILS]
 GROUP BY ORDERID, PRODUCTID WITH CUBE
 ORDER BY ORDERID, PRODUCTID
--GROUPING IDENTIFICA QUAL E A COLUNA QUE ESTA SENDO "SOMADA"
SELECT ORDERID, GROUPING(ORDERID),
       PRODUCTID, GROUPING(PRODUCTID),
       SUM(QUANTITY) AS QUANT_TOTAL,
       SUM(QUANTITY*UNITPRICE) AS VALOR_TOTAL
 FROM [ORDER DETAILS]
 GROUP BY ORDERID, PRODUCTID WITH CUBE
 ORDER BY ORDERID, PRODUCTID
--COMPUTE BY E SIMILAR AO ROLLUP, GERANDO QUEBRAS DE LINHAS
SELECT ORDERID, PRODUCTID, QUANTITY,
       QUANTITY*UNITPRICE AS VALOR_TOTAL
 FROM [ORDER DETAILS]
 ORDER BY ORDERID, PRODUCTID
COMPUTE SUM(QUANTITY), SUM(QUANTITY*UNITPRICE) BY ORDERID
COMPUTE SUM(QUANTITY), SUM(QUANTITY*UNITPRICE)
