USE PUBS
GO
--ALIAS PARA ABREVIACAO NAS TABELAS
SELECT A.AU_LNAME, A.AU_FNAME
  FROM AUTHORS AS A
--JOIN SIMPLES, CORRESPONDENCIA EM TODAS AS TABELAS
SELECT A.AU_FNAME, A.AU_LNAME, T.TITLE, T.TYPE
  FROM TITLEAUTHOR AS TA
 INNER JOIN AUTHORS AS A
       ON TA.AU_ID = A.AU_ID
 INNER JOIN TITLES AS T
       ON TA.TITLE_ID = T.TITLE_ID
--LEFT/RIGHT JOIN FAZEM A JUNO SEM QUE A CORRESPONDENCIA SEJA ENCONTRADA
SELECT A.AU_FNAME, A.AU_LNAME, T.TITLE, T.TYPE
  FROM TITLEAUTHOR AS TA
 RIGHT JOIN AUTHORS AS A
       ON TA.AU_ID = A.AU_ID
  LEFT JOIN TITLES AS T
       ON TA.TITLE_ID = T.TITLE_ID

SELECT A.AU_FNAME, A.AU_LNAME, T.TITLE, T.TYPE
  FROM TITLEAUTHOR AS TA
 RIGHT JOIN AUTHORS AS A
       ON TA.AU_ID = A.AU_ID
 RIGHT JOIN TITLES AS T
       ON TA.TITLE_ID = T.TITLE_ID

SELECT A.AU_FNAME, A.AU_LNAME, T.TITLE, T.TYPE
  FROM TITLEAUTHOR AS TA
  FULL JOIN AUTHORS AS A
       ON TA.AU_ID = A.AU_ID
  FULL JOIN TITLES AS T
       ON TA.TITLE_ID = T.TITLE_ID
--USO DE CROSS JOIN
DROP TABLE EMPREGADOS
GO
CREATE TABLE EMPREGADOS(NOME VARCHAR(30), GERENTE VARCHAR(30), IDADE INT)
GO
INSERT EMPREGADOS VALUES('JOAO','JOAO',30)
INSERT EMPREGADOS VALUES('JOAQUIM','JOAO',31)
INSERT EMPREGADOS VALUES('MARIA','JOAQUIM',32)
INSERT EMPREGADOS VALUES('MANUEL','JOAQUIM',33)
INSERT EMPREGADOS VALUES('SOARES','JOAQUIM',34)
GO
SELECT E1.NOME, E1.IDADE, E2.NOME, E2.IDADE
  FROM EMPREGADOS AS E1
 CROSS JOIN EMPREGADOS AS E2
 WHERE E1.GERENTE = E2.NOME
--JUNTANDO A TABELA DE AUTORES COM OS CLIENTES DA NORTHWIND
SELECT CONTACTNAME, CONTACTTITLE, PHONE, 'NORTHWIND'
  FROM NORTHWIND..CUSTOMERS
UNION ALL
SELECT AU_FNAME+' '+AU_LNAME, 'AUTHOR', '', 'PUBS'
  FROM AUTHORS
 ORDER BY 1
--A CLAUSULA ON DO JOIN PERMITE AS CONDICOES
SELECT A.AU_FNAME, A.AU_LNAME, T.TITLE, T.TYPE
  FROM TITLEAUTHOR AS TA
 INNER JOIN AUTHORS AS A
       ON TA.AU_ID = A.AU_ID
 INNER JOIN TITLES AS T
       ON TA.TITLE_ID = T.TITLE_ID AND T.TYPE='BUSINESS'
--INTO CRIA UMA NOVA TABELA, PERMANENTE OU TEMPORARIA
--COM # A TABELA S  NA CONEXO, COM ## A TABELA  PUBLICA
SELECT A.AU_FNAME, A.AU_LNAME, T.TITLE, T.TYPE
--INTO NOVATABELA
--INTO #NOVATABELA
--INTO ##NOVATABELA
  FROM TITLEAUTHOR AS TA
 INNER JOIN AUTHORS AS A
       ON TA.AU_ID = A.AU_ID
 INNER JOIN TITLES AS T
       ON TA.TITLE_ID = T.TITLE_ID
