USE NORTHWIND
GO
--SUB-SELECT CRIANDO TABELA FONTE
SELECT O.*, C.*
  FROM (SELECT *
          FROM CUSTOMERS) AS C
  INNER JOIN ORDERS AS O
        ON C.CUSTOMERID=O.CUSTOMERID
--SUB-SELECT NAS COLUNAS
SELECT C.COMPANYNAME,
       (SELECT SUM(QUANTITY*UNITPRICE)
          FROM ORDERS AS O 
         INNER JOIN [ORDER DETAILS] AS OD
               ON O.ORDERID = OD.ORDERID
         WHERE O.CUSTOMERID = C.CUSTOMERID
           AND MONTH(ORDERDATE)=1
           AND YEAR(ORDERDATE)=1998) AS JANEIRO,
       (SELECT SUM(QUANTITY*UNITPRICE)
          FROM ORDERS AS O 
         INNER JOIN [ORDER DETAILS] AS OD
               ON O.ORDERID = OD.ORDERID
         WHERE O.CUSTOMERID = C.CUSTOMERID
           AND MONTH(ORDERDATE)=2
           AND YEAR(ORDERDATE)=1998) AS FEVEREIRO,
       (SELECT SUM(QUANTITY*UNITPRICE)
          FROM ORDERS AS O 
         INNER JOIN [ORDER DETAILS] AS OD
               ON O.ORDERID = OD.ORDERID
         WHERE O.CUSTOMERID = C.CUSTOMERID
           AND MONTH(ORDERDATE)=3
           AND YEAR(ORDERDATE)=1998) AS MARCO,
       (SELECT SUM(QUANTITY*UNITPRICE)
          FROM ORDERS AS O 
         INNER JOIN [ORDER DETAILS] AS OD
               ON O.ORDERID = OD.ORDERID
         WHERE O.CUSTOMERID = C.CUSTOMERID
           AND MONTH(ORDERDATE)=4
           AND YEAR(ORDERDATE)=1998) AS ABRIL,
       (SELECT SUM(QUANTITY*UNITPRICE)
          FROM ORDERS AS O 
         INNER JOIN [ORDER DETAILS] AS OD
               ON O.ORDERID = OD.ORDERID
         WHERE O.CUSTOMERID = C.CUSTOMERID
           AND MONTH(ORDERDATE)=5
           AND YEAR(ORDERDATE)=1998) AS MAIO,
       (SELECT SUM(QUANTITY*UNITPRICE)
          FROM ORDERS AS O 
         INNER JOIN [ORDER DETAILS] AS OD
               ON O.ORDERID = OD.ORDERID
         WHERE O.CUSTOMERID = C.CUSTOMERID
           AND MONTH(ORDERDATE)=6
           AND YEAR(ORDERDATE)=1998) AS JUNHO
  FROM CUSTOMERS AS C
 ORDER BY COUNTRY
--SUB-SELECT EM COLUNA, EXEMPLO 2
SELECT C.COMPANYNAME,
       (SELECT MIN(ORDERDATE)
          FROM ORDERS AS OD
         WHERE OD.CUSTOMERID = C.CUSTOMERID) AS PRIMEIRO,
       (SELECT MAX(ORDERDATE)
          FROM ORDERS AS OD
         WHERE OD.CUSTOMERID = C.CUSTOMERID) AS ULTIMO,
       (SELECT TOP 1 PRODUCTID
          FROM [ORDER DETAILS] AS OD
         INNER JOIN ORDERS AS ORD
               ON ORD.ORDERID=OD.ORDERID
         WHERE ORD.CUSTOMERID=C.CUSTOMERID
         ORDER BY QUANTITY) AS MENOS_COMPRADO,
       (SELECT TOP 1 PRODUCTID
          FROM [ORDER DETAILS] AS OD
         INNER JOIN ORDERS AS ORD
               ON ORD.ORDERID=OD.ORDERID
         WHERE ORD.CUSTOMERID=C.CUSTOMERID
         ORDER BY QUANTITY DESC) AS MAIS_COMPRADO
  FROM CUSTOMERS AS C
--SUB-SELECT NO WHERE PARA CONSTRUCAO DE CONDICAO
SELECT * 
  FROM ORDERS
 WHERE ORDERDATE = (SELECT MAX(ORDERDATE)
                      FROM ORDERS)
--SUB-SELECT QUE GERA UMA LISTA COM CODIGOS
SELECT SUM(QUANTITY*UNITPRICE) AS TOTAL, COMPANYNAME
  FROM CUSTOMERS AS C
 INNER JOIN ORDERS AS O
    ON C.CUSTOMERID = O.CUSTOMERID
 INNER JOIN [ORDER DETAILS] AS OD
    ON OD.ORDERID = O.ORDERID
 WHERE C.CUSTOMERID
    IN (SELECT C.CUSTOMERID
          FROM CUSTOMERS AS C
         INNER JOIN ORDERS AS O
            ON C.CUSTOMERID = O.CUSTOMERID
         INNER JOIN [ORDER DETAILS] AS OD
            ON OD.ORDERID=O.ORDERID
         GROUP BY C.CUSTOMERID
        HAVING SUM(QUANTITY*UNITPRICE) > 5000)
 GROUP BY COMPANYNAME
--SUB-SELECT NO IN, EXEMPLO 2
SELECT *
  FROM CUSTOMERS
 WHERE CITY+COUNTRY
       IN (SELECT CITY+COUNTRY
             FROM CUSTOMERS
            WHERE COUNTRY='BRAZIL')
--SUB-SELECT COM EXISTS
SELECT *
  FROM CUSTOMERS AS C
 WHERE EXISTS(SELECT *
                FROM ORDERS AS O
               WHERE O.CUSTOMERID=C.CUSTOMERID)
--SUB-SELECT PARA INSERCAO
CREATE TABLE CLIENTES(EMPRESA VARCHAR(100), CONTATO VARCHAR(100))
GO
INSERT CLIENTES SELECT COMPANYNAME, CONTACTNAME
                  FROM CUSTOMERS
